<template>

    <div class="main">
      <div class="wrap-subtitle">
        <h3 class="sub-title">Categories</h3>
        
      </div>
      <carousel :margin="10" :dots="false" :nav="false"
                :responsive="{
                  0:{items:2},576:{items:3},768:{items:4},1200:{items:6},1500:{items:8}
                }"
                @changed="syncArrow('categoryNext', 'categoryPrev', categoryArrow)">
        <template slot="prev"><span class="category-prev" ref="categoryNext">prev</span></template>
        <template slot="next"><span class="category-next" ref="categoryPrev">next</span></template>
        <div class="product-item" v-for="item in cats" :key="item.id">
          <router-link :to="item.link">
            <div class="wrap-image square">
              <img :src="item.image">
            </div>
            <h4 class="title">{{item.title}}</h4>
          </router-link>
        </div>
      </carousel>
      <br>
      <div class="wrap-subtitle">
        <h3 class="sub-title">Premiums</h3>
        
      </div>
      <carousel :margin="10" :dots="false" :nav="false"
                :responsive="{
                  0:{items:2},576:{items:3},768:{items:4},1200:{items:6},1500:{items:8}
                }"
                @changed="syncArrow('categoryNext', 'categoryPrev', categoryArrow)">
        <template slot="prev"><span class="category-prev" ref="categoryNext">prev</span></template>
        <template slot="next"><span class="category-next" ref="categoryPrev">next</span></template>
        <div class="product-item" v-for="item in premiums" :key="item.id">
          <router-link :to="item.link">
            <div class="wrap-image square">
              <img :src="item.photo">
            </div>
            <h4 class="title">{{item.title}}</h4>
          </router-link>
        </div>
      </carousel>
       <br>
      <div class="wrap-subtitle">
        <h3 class="sub-title">Others</h3>
        
      </div>
      <carousel :margin="10" :dots="false" :nav="false"
                :responsive="{
                  0:{items:2},576:{items:3},768:{items:4},1200:{items:6},1500:{items:8}
                }"
                @changed="syncArrow('categoryNext', 'categoryPrev', categoryArrow)">
        <template slot="prev"><span class="category-prev" ref="categoryNext">prev</span></template>
        <template slot="next"><span class="category-next" ref="categoryPrev">next</span></template>
        <div class="product-item" v-for="item in others" :key="item.id">
          <router-link :to="item.link">
            <div class="wrap-image square">
              <img :src="item.photo">
            </div>
            <h4 class="title">{{item.title}}</h4>
          </router-link>
        </div>
      </carousel>
  </div>
</template>

<script>
import carousel from 'vue-owl-carousel'

const items = [
  {
    title: "Shopping",
  }
]

const cats = [
  {
    title: "Genres and Mood",
    image: "https://i.scdn.co/image/ab67706f00000002d32556d7498a9be15e6f12d5",
    id: 1,
    link: '/Mood'
  },
  {
    title: "Charts",
    image: "https://i.scdn.co/image/ab67706f00000002d32556d7498a9be15e6f12d5",
    id: 2,
    link: '/Chart'
  },
  {
    title: "New Release",
    image: "https://i.scdn.co/image/ab67616d0000b27338e349efcd6a1c63e403b97f",
    id: 3,
    link: '/Release'
  },
  {
    title: "Recent Played",
    image: "https://i.scdn.co/image/ab67616d0000b27395fda4ae504c97e15fd6addd",
    id: 4,
    link: '/Chart'
  },
  {
    title: "Liked songs",
    image: "https://i.scdn.co/image/ab67706f00000002d32556d7498a9be15e6f12d5",
    id: 5,
    link: '/Release'
  },
  {
    title: "Albums",
    image: "https://i.scdn.co/image/ab67706f00000002b67a735b799113e3bf38d97d",
    id: 6,
    link: '/Mood'
  },
  {
    title: "Artists",
    image: "https://i.scdn.co/image/ab67706f00000002c12758afba5ea752c69492f6",
    id: 7,
    link: '/Chart'
  }
]
const premiums = [
  {
    id: 1,
    title: "All sounds",
    photo: "sound.png",
    link: '/sound'
  },
  {
    id: 2,
    title: "Songs",
    photo: "song.png",
    link: '/song'
  },
  {
    id: 3,
    title: "Beat",
    photo: "beat.png",
    link: '/beat'
  },
  {
    id: 4,
    title: "BGM",
    photo: "bgm.jpg",
    link: '/bgm'
  }
]
const others = [
  {
    id: 1,
    title: "Voting game",
    photo: "voting.jpg",
    link: '/voting'
  },
  {
    id: 2,
    title: "Go Fund Me",
    photo: "fund.png",
    link: '/gofundme'
  },
  {
    id: 3,
    title: "Shopping",
    photo: "shopping.jpg",
    link: 'Shopping'
  },
  {
    id: 4,
    title: "GSMT",
    photo: "gsmt.jpg",
    link: 'gsmt'
  }
]

export default {
  components: {carousel},
  data() {
    return {
      title: 'Shopping',
      categoryArrow: {
        prev: true,
        next: true,
      },
      productArrow: {
        prev: true,
        next: true,
      },
      cats: cats,
      premiums: premiums,
      others: others
    }
  },

  methods: {
    isMobile() {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true
      } else {
        return false
      }
    },
    syncArrow(prev, next, arrowObject) {
      const me = this;
      setTimeout(function () {
        const prevParent = me.$refs[prev] && me.$refs[prev].parentNode;
        const nextParent = me.$refs[next] && me.$refs[next].parentNode;
        if (prevParent) {
          arrowObject.prev = prevParent.style.display !== 'none';
        }
        if (nextParent) {
          arrowObject.next = nextParent.style.display !== 'none';
        }
      }, 200)
    },
    triggerClick(ref) {
      this.$refs[ref].click();
    }
  },
  mounted: function () {
    this.syncArrow('categoryNext', 'categoryPrev', this.categoryArrow);
    this.syncArrow('productNext', 'productPrev', this.productArrow);
  }
}

</script>

<style scoped>
@import "../css/default.css";

.slide-item {
  position: relative;
}

.slide-item:hover img {
  opacity: 0.7;
}

.wrap-image img {
  opacity: 0.5;
}

.slide-item .title {
  position: absolute;
  width: 100%;
  bottom: 0;
  font-size: 20px;
  padding: 10px;
  font-weight: 400;
}
.product-item .title{
  font-size: 18px;
  text-transform: uppercase;
  padding: 5px 0;
  font-weight: 400;
}

.category-prev, .category-next,.product-prev, .product-next {
  position: absolute;
  z-index: -1;
}
.product-item:hover img {
  opacity: 0.7;
}

</style>
